#! /usr/bin/python
# -*- coding: utf-8 -*-
if __name__ == "__main__":											# Si es invocado externamente....

	# Imports
	import MySQLdb
	import sys
	import syslog

	# Abrirl el fichero de LOG
	syslog.openlog("GONG actualizar_cm.py", syslog.LOG_USER)

	#Informar
	msg="Inicio del Proceso de Actualizacion de Cuadro de Mando."
	print msg
	syslog.syslog(syslog.LOG_NOTICE, msg)

	# Control del número de parámetros
	if len(sys.argv)!=2:
		msg="ERROR 1: Numero de parametros incorrecto en la invocacion a este comando. El proceso no puede continuar."
		print msg
		# logptr.write(msg + "\n")
		syslog.syslog(syslog.LOG_ERR,msg)
		sys.exit(1)

	# Definir variables
	# host = 'localhost'
	
	# Cargar valores configuración
	try:
		a=open(sys.argv[1])
		for u in a:
			if (u.find("gor_cm.jdbcUser")==0):
				# trim
				user = u.split("=")[1].replace('\n','')
			if (u.find("gor_cm.jdbcPassword")==0):
				# trim
				passwd = u.split("=")[1].replace('\n','')
			if (u.find("gor_cm.jdbcUrl")==0):
				# trim
				# COGER A LA DERECHA DEL =  EL ULTIMO STRING SEPARADO POR /
				db = u.split("=")[1].split("/")[-1].replace('\n','')
			if (u.find("gor_cm.jdbcUrl")==0):
				# trim
				# COGER A LA DERECHA DEL =  EL ULTIMO STRING SEPARADO POR /
				host = u.split("=")[1].split("/")[-2]
			if (u.find("gor_cm.jdbcDBName")==0):
				# trim
				dbname = u.split("=")[1].replace('\n','')
	except :
		# Error al recuperar los valores de configuración
		msg="ERROR 2: No se pudo cargar los valores de conexion del fichero de configuracion de la ruta " + sys.argv[1] + ". El proceso no puede continuar."
		print msg
		syslog.syslog(syslog.LOG_ERR,msg)
		sys.exit(2)

	try:
		# Conectar con MYSQL
		mydb=MySQLdb.connect( host, user, passwd, db, charset = "utf8", use_unicode = True )
		# FALTA CONTROL DE ERROR
		conex=mydb.cursor()
		msg="Conectado correctamente con BD (host: " + host + ", db: " + db + ", user: " + user +  ")."
		print msg
		syslog.syslog(syslog.LOG_NOTICE,msg)
	
	except :
		# Error al realizar la conexion
		msg=" ERROR 3: No se pudo realizar la conexion con BD (host: " + host + ", db: " + db + ", user: " + user + ")." 
		print msg
		syslog.syslog(syslog.LOG_ERR,msg)
		sys.exit(3)

	try:
		# Cambiar de base de datos
		msg="Cambiando a la BD de CM." 
		print msg
		syslog.syslog(syslog.LOG_NOTICE,msg)

		conex.execute("USE gong_cm;")

	except MySQLdb.Error, e:
		# Error al cambiar de base de datos
		msg="ERROR 4: Error al cambiar a la base de datos de CM." + " Error %d: %s" % (e.args[0], e.args[1]) 
		print msg
		syslog.syslog(syslog.LOG_ERR,msg)
		sys.exit(4)
	
	try:
		# Ejecutar el proceso
		#conex.execute("CALL carga_hechos ('" + dbname + "');")

		mivar="CALL carga_todo ('" + dbname + "');"
		msg="Ejecutando el proceso de actualización en la BD: " + mivar 
		print msg
		syslog.syslog(syslog.LOG_NOTICE,msg)
		conex.execute(mivar)

		msg="El proceso ha finalizado sin reportar error." 
		print msg
		syslog.syslog(syslog.LOG_NOTICE,msg)
	except MySQLdb.Error, e:
		# Error al invocar el procedimiento almacenado
		msg="ERROR 5: Error al invocar el procedimiento almacenado 'carga_todo' (host: " + host + ", db: " + db + ", user: " + user + ")." + " Error %d: %s" % (e.args[0], e.args[1]) 
		print msg
		syslog.syslog(syslog.LOG_ERR,msg)
		sys.exit(5)

